// HighResolutionTime.cpp: implementation of the HighResolutionTime class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HighResolutionTime.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HighResolutionTime::HighResolutionTime()
{
	theFrequencyCount.QuadPart = 0;
}

HighResolutionTime::~HighResolutionTime()
{

}

LARGE_INTEGER HighResolutionTime::getFrequencyCount()
{
	if (theFrequencyCount.QuadPart == 0) {
		QueryPerformanceFrequency(&theFrequencyCount);
	}
	return theFrequencyCount;
}

LARGE_INTEGER HighResolutionTime::getTimeMicroSeconds()
{
	// Convert the time to microSeconds
	LARGE_INTEGER result;
	result.QuadPart = getTimeSecsInternal() * 1000000;
	return result;
}

double HighResolutionTime::getTimeSecsInternal()
{
	// Get the time in ticks
	QueryPerformanceCounter(&theWorkingLargeInteger);

	// Convert the time to seconds
	return (double) ((double) theWorkingLargeInteger.QuadPart / (double) getFrequencyCount().QuadPart);
}

long HighResolutionTime::getTimeMilliSeconds()
{
	return (long) (getTimeSecsInternal() * 1000);
}

long HighResolutionTime::getTimeSeconds()
{
	return (long) getTimeSecsInternal();
}

int operator-(const LARGE_INTEGER& arg1, const LARGE_INTEGER& arg2)
{
	int result = arg1.QuadPart - arg2.QuadPart;

	return result;
}

